#!/bin/bash

R='rasql --user rasadmin --passwd rasadmin --quiet'
c=Backscatter_Sentinel1_Track015_slow
f=20x25834_float_float.bin

if [ "$1" = "ingest" ]; then

  echo preparing data...

  $R -q "drop collection $c" > /dev/null 2>&1
  $R -q "drop type ${c}_Set" > /dev/null 2>&1
  $R -q "drop type ${c}_Array" > /dev/null 2>&1
  $R -q "drop type ${c}_Pixel" > /dev/null 2>&1

  $R -q "create type ${c}_Pixel as (a float, b float)"
  $R -q "create type ${c}_Array as ${c}_Pixel mdarray [t,x,y]"
  $R -q "create type ${c}_Set as set (${c}_Array null values [-999.0])"

  $R -q "create collection $c ${c}_Set"
  $R -q "insert into $c values <[0:0,0:0,0:0] {0f,0f}>"

  update_time_slice()
  {
    local t="$1"
    while [ $x -lt 3000 ]; do
      x=$((x+1))
      x1=$((x+19))
      $R -q "update $c as m set m assign \$1" -f "$f" --mdddomain "[$t:$t,$x:$x1,0:25833]" --mddtype "${c}_Array"
      x=$x1
    done
  }

  $R -q "update $c as m set m assign marray i in [0:0,0:0,1:25833] values {0f,0f}"
  x=0
  update_time_slice 0

  $R -q "update $c as m set m assign marray i in [1:1,0:19,0:25833] values {0f,0f}"
  x=19
  update_time_slice 1

  $R -q "update $c as m set m assign marray i in [2:2,0:19,0:25833] values {0f,0f}"
  x=19
  update_time_slice 1

fi

echo running test...

time rasql --user rasguest --passwd rasguest -q 'SELECT encode(MARRAY T1 in [0:2,0:19,2392:2411] VALUES  ( c.0[T1[0],T1[1],T1[2]] -  ( CONDENSE max OVER pt in [0:2]  USING c.0[pt[0],T1[1],T1[2]] )  ) , "csv" ) FROM '"$c"' AS c' > /dev/null

#time rasql --user rasguest --passwd rasguest -q 'SELECT encode(MARRAY T1 in [0:2,0:19,2392:2411] VALUES  ( c.0[T1[0],T1[1],T1[2]] -  max_cells( c.0[0:2,T1[1],T1[2]]  )) , "csv" ) FROM '"$c"' AS c' > /dev/null

#valgrind --tool=memcheck directql -q 'SELECT encode(MARRAY T in [0:2,0:1,25832:25833] VALUES c.1[T[0],T[1],T[2]] / c.1[0,T[1],T[2]], "json" , "{}") FROM '"$c"' AS c' --out string

echo done.
